﻿Type=Class
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Private Sub Class_Globals
	Private MeasureHeightOfText As StringUtils 
	
	Private WidthOfLineBefore , WidthOfLineAfter , WidthRatioBefore , WidthRatioAfter , Rate , HeightOfText , Extra As Float : Extra = 0
	Private linecount As Int	
	
	Private Jo , Paint As JavaObject
	Private Bounds As Rect
	Private R As Reflector

End Sub

Public Sub Initialize

End Sub


'Scale the text size of target view based on new width of view 
'The text will be always one line and the aspect ratio will be preserved
'Text size will be increased as long as the height of text is NOT greater than the height of view
'Width : The width of a view before any changes in its dimensions
'TextSize : The text size of a view before any changes in its dimensions
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.SingleLineAutoScale(TextView , 100dip , 12)
Public Sub SingleLineAutoScale(TargetView As Object , Width As Int , TextSize As Int)
	Dim lbl As Label = TargetView
		
	
		If getLineCount(TargetView) > 1 Then 	
			'should be set maximum text size
			CallSubDelayed3(Me,"SingleLineFitText",TargetView,True)
			Return
		Else
			'is one line so continue
			WidthOfLineBefore = getTextWidth(TargetView , lbl.Typeface ,TextSize)
			WidthRatioBefore = WidthOfLineBefore / Width 
		End If	
		
		'set maximum text size 
		lbl.TextSize = 72 
		Rate = lbl.TextSize
		DoEvents
		
		'measure width of text after and height of text
		WidthOfLineAfter = getTextWidth(lbl , lbl.Typeface ,lbl.TextSize)
		WidthRatioAfter = WidthOfLineAfter / lbl.Width 	
		'height of text can not be larger than the height of view
		HeightOfText = getTextHeight(lbl)
		
		'measure line count
		linecount = getLineCount(lbl)
		
		'set text size in a while loop
		Do While Rate > 0.5 Or linecount > 1 Or HeightOfText > lbl.Height Or WidthRatioAfter > WidthRatioBefore
			Rate = Rate / 2	
				If WidthRatioAfter > WidthRatioBefore Or HeightOfText > lbl.Height Or linecount > 1 Then 
					lbl.TextSize = lbl.TextSize - Rate
				Else 
					lbl.TextSize = lbl.TextSize + Rate
				End If
				DoEvents		
				
				'measure width and height and line count with new text size
				WidthOfLineAfter = getTextWidth(lbl , lbl.Typeface ,lbl.TextSize)
				WidthRatioAfter = WidthOfLineAfter / lbl.Width 	
				HeightOfText = getTextHeight(lbl)
				linecount = getLineCount(lbl)	
		Loop
End Sub


'Fit your text in view as long as the height of text is NOT greater than height of the view
'The text will be always one line
'CanBeLarger : if this option be false then your text will be fitted just if your text is more than 1 line
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.SingleLineFitText(TextView , True)
Public Sub SingleLineFitText(TargetView As Object,CanBeLarger As Boolean)
	Dim lbl As Label = TargetView 
		
		'when our text is still 1 line and we dont want to increase text size
		If (getLineCount(TargetView) = 1) And (CanBeLarger = False) Then Return
			'set maximum text size 
			lbl.TextSize = 72 
			Rate = lbl.TextSize
			DoEvents
			
			'measure height of text
			HeightOfText = getTextHeight(lbl)
			
			'measure line count
			linecount = getLineCount(lbl)
			
			'set text size in a while loop
			Do While Rate > 0.5 Or linecount > 1 Or HeightOfText > lbl.Height
				Rate = Rate / 2	
					If HeightOfText > lbl.Height Or linecount > 1 Then 
						lbl.TextSize = lbl.TextSize - Rate
					Else 
						lbl.TextSize = lbl.TextSize + Rate
					End If
					DoEvents		
					
					'measure height and line count with new text size
					HeightOfText = getTextHeight(lbl)
					linecount = getLineCount(lbl)		
			Loop

End Sub


'Text size will be increased or decreased as long as the height of text is NOT greater than height of the view)
'MaximumLineCount: line count can't be more than given maximum line count
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.MultiLineLimited(TextView , 3)
Public Sub MultiLineLimited(TargetView As Object,MaximumLineCount As Int)

	Dim lbl As Label = TargetView 
		
			'set maximum text size 
			lbl.TextSize = 72
			Rate = lbl.TextSize
			DoEvents
			
			'measure height of text
			HeightOfText = getTextHeight(lbl)
			'measure line count
			linecount = getLineCount(lbl)
			
			'set text size in a while loop
			Do While Rate > 0.5 Or linecount > MaximumLineCount Or HeightOfText > lbl.Height
				Rate = Rate / 2	
					If HeightOfText > lbl.Height Or linecount > MaximumLineCount Then 
						lbl.TextSize = lbl.TextSize - Rate
					Else 
						lbl.TextSize = lbl.TextSize + Rate
					End If	
					DoEvents	
					
					'measure height and line count with new text size
					HeightOfText = getTextHeight(lbl)
					linecount = getLineCount(lbl)		
			Loop
		
End Sub


'Fit your text in view as long as the height of text is NOT greater than height of the view
'CanBeLarger: if this option be false then your text will be fitted just if your text height is more than height of the view
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.MultiLineFitText(TextView , True)
Public Sub MultiLineFitText(TargetView As Object,CanBeLarger As Boolean)
	Dim lbl As Label = TargetView 
		
		'measure height of text
		HeightOfText = getTextHeight(lbl)	
		
		'if height of our text is smaller than height of the view then don't set maximum text size to view
		If (HeightOfText <= lbl.Height) And (CanBeLarger = False) Then Return
		
		'set maximum size to fit the text into view
		lbl.TextSize = 72 
		Rate = lbl.TextSize	
		DoEvents
		
		'measure again new height after changing text size
		HeightOfText = getTextHeight(lbl)	
		
		'set text size in a while loop
		Do While Rate > 0.5 Or HeightOfText > lbl.Height
			Rate = Rate / 2	
				If HeightOfText > lbl.Height Then 
					lbl.TextSize = lbl.TextSize - Rate
				Else 
					lbl.TextSize = lbl.TextSize + Rate
				End If	
				DoEvents	
				
				'measure height of text with new text size
				HeightOfText = getTextHeight(lbl)
		Loop
		
End Sub


'EllipSizeMode : Cut your text with choosen mode
'Can Be "Start" or "Middle" or "End" or "Marquee"
'MarqueeRepeatLimit:If you choose "Marquee" mode then you can choose marquee repeat count too
'set -1 for repeat indefinitely or for stop marquee
'--------------------------------------------------------------
'Example:
'Dim SmartString1 as SmartString
'SmartString1.Initialize
'SmartString1.Ellipsize(Label1,"Marquee",-1)
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.Ellipsize(TextView , "END" , 0)
Sub Ellipsize(TargetView As Object,EllipSizeMode As String,MarqueeRepeatLimit As Int)
		Jo = TargetView
		EllipSizeMode = EllipSizeMode.ToUpperCase

			Select EllipSizeMode
				Case "END","START","MIDDLE"
					Jo.RunMethod("setEllipsize", Array As Object(EllipSizeMode))
				Case "MARQUEE"
					If MarqueeRepeatLimit=0 Then
						Jo.RunMethod("setEllipsize", Array As Object("MARQUEE"))
						Jo.RunMethod("setHorizontallyScrolling",Array As Object(False))
					Else
						Jo.RunMethod("setSingleLine", Array As Object(True))
						Jo.RunMethod("setEllipsize", Array As Object(EllipSizeMode))
						Jo.RunMethod("setSelected", Array As Object(True)) 
						Jo.RunMethod("setMarqueeRepeatLimit", Array As Object(MarqueeRepeatLimit))
					End If
			End Select
End Sub


'LineCount: Cut your string if be larger than given number of line
'EllipsizeModeIfNeeded : ellipsize your text if be larger than maximum size
'MarqueeRepeatLimitIfNeeded: If you choose marquee mode for ellipsize then you can limit marquee repeat count too
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.SetLineCount(TextView , 2 , "END" , 0)
Sub SetLineCount(TargetView As Object,MaximumLinesCount As Int,EllipsizeModeIfNeeded As String,MarqueeRepeatLimitIfNeeded As Int)
	Jo = TargetView
		If MaximumLinesCount = 0 Or MaximumLinesCount = 1 Then   
			Jo.RunMethod("setSingleLine", Array As Object(True))
		Else if MaximumLinesCount > 1 Then
			Jo.RunMethod("setLines", Array As Object(MaximumLinesCount))
		End If
		
		If EllipsizeModeIfNeeded.Trim <> "" And EllipsizeModeIfNeeded.Trim <> Null Then Ellipsize(TargetView,EllipsizeModeIfNeeded.ToUpperCase,MarqueeRepeatLimitIfNeeded)
End Sub


'Set spaces between lines
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.SetLineSpace(TextView ,0.75)
public Sub SetLineSpace(TargetView As Object, Multiplier As Float)
	Jo = TargetView : Jo.RunMethod("setLineSpacing", Array As Object(Extra, Multiplier))
 End Sub

Private Sub getTextWidth(TargetView As Label,TP As Typeface,TextSize As Float) As Float
	'measure width of text
    Bounds.Initialize(0,0,0,0)
    Paint.InitializeNewInstance("android.graphics.Paint",Null)
        Paint.RunMethod("setTextSize",Array(TextSize))
        Paint.RunMethod("setTypeface",Array(TP))
        Paint.RunMethod("getTextBounds",Array(TargetView.Text,0,TargetView.Text.Length,Bounds))

		r.Target=TargetView
   		r.Target = r.GetContext
   		r.Target = r.RunMethod("getResources")
    	r.Target = r.RunMethod("getDisplayMetrics")
		Return((Bounds.Right - Bounds.Left)* r.GetField("xdpi")/ 160)
End Sub
Private Sub getTextHeight(TargetView As Label) As Float
	Return MeasureHeightOfText.MeasureMultilineTextHeight(TargetView,TargetView.Text)
End Sub

private Sub getLineCount(TargetView As Object) As Int
	Jo = TargetView
	Return Jo.RunMethod("getLineCount",Null)
End Sub